# swagger-client
Multilogin Local REST API can be used in order to start, stop, share, clone browser profile/-s. You can also check if the profile is already running on your machine by using checkProfileRunning endpoint and import cookies by using cookieImportJSON/cookieImportNetscape endpoint.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com//.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com//.git`)

Then import the package:
```python
import multiloginlocal 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import multiloginlocal
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import multiloginlocal
from multiloginlocal.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = multiloginlocal.MiscApi(multiloginlocal.ApiClient(configuration))
profile_id = 'profile_id_example' # str | Browser profile ID

try:
    # checkProfileRunning
    api_instance.active_get(profile_id)
except ApiException as e:
    print("Exception when calling MiscApi->active_get: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost.multiloginapp.com:35000/api/v1/profile*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*MiscApi* | [**active_get**](docs/MiscApi.md#active_get) | **GET** /active | checkProfileRunning
*MiscApi* | [**by_profile_id_get**](docs/MiscApi.md#by_profile_id_get) | **GET** /clone | cloneProfile
*MiscApi* | [**cookies_import_netscape_get**](docs/MiscApi.md#cookies_import_netscape_get) | **POST** /cookies/import/netscape | cookieImportNetscape
*MiscApi* | [**cookies_import_webext_get**](docs/MiscApi.md#cookies_import_webext_get) | **POST** /cookies/import/webext | cookieImportJSON
*MiscApi* | [**share_get**](docs/MiscApi.md#share_get) | **GET** /share | shareProfile
*MiscApi* | [**start_get**](docs/MiscApi.md#start_get) | **GET** /start | startProfile
*MiscApi* | [**stop_get**](docs/MiscApi.md#stop_get) | **GET** /stop | stopProfile


## Documentation For Models

 - [CloneOkResonse](docs/CloneOkResonse.md)
 - [CookieJSONExample](docs/CookieJSONExample.md)
 - [CookieNetscapeExample](docs/CookieNetscapeExample.md)
 - [MainErrorResponse](docs/MainErrorResponse.md)
 - [MainOkResponse](docs/MainOkResponse.md)
 - [ProfileActiveErrorResponse](docs/ProfileActiveErrorResponse.md)
 - [ProfileActiveOkResponse](docs/ProfileActiveOkResponse.md)


## Documentation For Authorization

 All endpoints do not require authorization.


## Author



